Attribute VB_Name = "mEnumWindows"
Private Declare Function EnumWindows& Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long)
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function IsWindowVisible& Lib "user32" (ByVal hWnd As Long)
Private Declare Function GetParent& Lib "user32" (ByVal hWnd As Long)

Dim lbx As ListBox

Public Sub EnumTopWindows(lb As ListBox)
   Set lbx = lb
   EnumWindows AddressOf EnumWinProc, 0
   If lbx.ListCount > 0 Then lbx.ListIndex = 0
   Set lbx = Nothing
End Sub

Function EnumWinProc(ByVal hWnd As Long, ByVal lParam As Long) As Long
   If (IsWindowVisible(hWnd)) And (GetParent(hWnd) = 0) Then
      lbx.AddItem "Title: " & GetWndText(hWnd) & "; Class: " & GetWndClass(hWnd)
      lbx.ItemData(lbx.NewIndex) = hWnd
   End If
   EnumWinProc = 1
End Function

Private Function GetWndClass(hWnd As Long) As String
  Dim k As Long, sName As String
  sName = Space$(128)
  k = GetClassName(hWnd, sName, 128)
  If k > 0 Then sName = Left$(sName, k) Else sName = "No class"
  GetWndClass = sName
End Function

Private Function GetWndText(hWnd As Long) As String
  Dim k As Long, sName As String
  sName = Space$(128)
  k = GetWindowText(hWnd, sName, 128)
  If k > 0 Then sName = Left$(sName, k) Else sName = "No name"
  GetWndText = sName
End Function

